package Main;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.ArrayList;

import Model.Music.UnfoldedSimplicialTonnetz;
import Model.Music.PlanarUnfoldedTonnetz;

public class HexaChord implements KeyListener {

	private static HexaChord singleton = null;

	private boolean _draw_subgrid = false;

	// Model
	private UnfoldedSimplicialTonnetz _tonnetz;
	private int _N;
	// private int _pos;

	private UnfoldedSimplicialTonnetz _chordTonnetz; // derived:
	// _chordSeq.get(_pos).getTonnetz()
	private boolean _dynamicTonnetz = false;

	// Control & view

	private GridFrame currentFrame;
	private PlanarUnfoldedTonnetz currentTonnetz;

	private HexaChord() {

		currentTonnetz = UnfoldedSimplicialTonnetz.getZ12HexaTonnetzList().get(10);
		new_frame(currentTonnetz);
	}

	private void update_derived_model() {

		currentFrame.repaint();
	}

	public UnfoldedSimplicialTonnetz getCurrentTonnetz() {
		if (_dynamicTonnetz)
			return _chordTonnetz;
		else
			return _tonnetz;
	}

	public UnfoldedSimplicialTonnetz getChordTonnetz() {
		return _chordTonnetz;
	}

	public void set_dynamicTonnetz(boolean _dynamicTonnetz) {
		this._dynamicTonnetz = _dynamicTonnetz;
		update_derived_model();
	}

	public UnfoldedSimplicialTonnetz getTonnetz() {
		return _tonnetz;
	}

	public void switch_draw_subgrid() {
		_draw_subgrid = !_draw_subgrid;

		currentFrame.switch_draw_subgrid();
		currentFrame.repaint();

	}

	public boolean get_draw_subgrid() {
		return _draw_subgrid;
	}

	// TODO
	public void new_frame(PlanarUnfoldedTonnetz t) {

		if (!currentTonnetz.equals(t) || this.currentFrame == null) {

			this.currentTonnetz = t;
			this.currentFrame = new GridFrame(t, this);

			update_derived_model();

		} else {
			// System.out.println("Tonnetz deja affich");
		}

	}

	public GridFrame getCurrentFrame() {
		return this.currentFrame;
	}

	// Key Events Listeners
	public void keyPressed(KeyEvent evt) {
		switch (evt.getKeyCode()) {
		case KeyEvent.VK_ESCAPE:
		case KeyEvent.VK_Q:
			this.currentFrame.dispose();
			break;
		case KeyEvent.VK_R:
			break;
		case KeyEvent.VK_I:
			this.currentFrame.saveFrameAsJepg();
			break;
		case KeyEvent.VK_S:
			set_dynamicTonnetz(false);
			break;
		case KeyEvent.VK_N:
			switch_draw_subgrid();
			break;
		case KeyEvent.VK_D:
			set_dynamicTonnetz(true);
			break;
		default:
			this.currentFrame.get_p().keyPressed(evt);
		}
	}

	public void keyReleased(KeyEvent evt) {
	}

	public void keyTyped(KeyEvent evt) {
	}

	public int get_N() {
		return _N;
	}

	public GridFrame getGridFrameFromTonnetz(PlanarUnfoldedTonnetz t) {

		new_frame(t);
		return this.currentFrame;

	}

	public static HexaChord getInstance() {
		if (singleton == null) {
			singleton = new HexaChord();
		}

		return singleton;
	}

}
