package Main;

import java.awt.Color;

import Interface.GridLayerInterviewer;
import Model.Music.Note;
import Model.Music.PlanarUnfoldedTonnetz;
import Utils.Gcd;

class MusicInterviewer1 extends GridLayerInterviewer {

	protected HexaChord _h;
	protected PlanarUnfoldedTonnetz _t;

	public MusicInterviewer1(HexaChord h, PlanarUnfoldedTonnetz t) {
		_h = h;
		_t = t;
	}

	@Override
	public String get_node_label(int X, int Y) {
		return Note.get_name(get_note(X, Y));
	}
	
	@Override
	public int get_node_pitch(int X, int Y){
		return _t.get_real_pitch_from_coords(X,Y);
	}

	@Override
	public Color get_node_color(int X, int Y) {
		return Color.lightGray;
	}

	@Override
	public Color get_edge_color() {
		return Color.lightGray;
	}

	@Override
	public Color get_label_color() {
		return Color.white;
	}

	@Override
	public boolean draw_edge() {
		return true;
	}
	
	@Override
	public boolean draw_node() {
		return true;
	}

	protected int get_note(int X, int Y) {
		// return Gcd.reduce(_h.getCurrentChordOrbit() + X *
		// _h.getCurrentTonnetz().get_generator(0) - Y *
		// _h.getCurrentTonnetz().get_generator(2),
		// _h.getCurrentTonnetz().get_N());
		//return Gcd.reduce(X * _t.get_generator(0) - Y * _t.get_generator(2), _t.get_N());
		return _t.get_scale().get(Gcd.reduce(X * _t.get_generator(0) - Y * _t.get_generator(2),_t.get_N()));
	}
}


