package Main;

import java.awt.Shape;
import java.util.ArrayList;

public class Node {

	private Shape shape; // forme exprime en pixels dans un repere (0,0)
							// (width,height)
	// private String decoration; //label
	private int pitch;
	private ArrayList<Edge> neighbor_edges = new ArrayList<Edge>(); // arcs
																	// voisins

	/**
	 * Construit un objet Hexa avec une forme de type shape (Rectangle, Polygon,
	 * Ellipse...)
	 * 
	 * @param shape
	 * @param decoration
	 * @param edges
	 */
	// public Node(Shape shape, String decoration, ArrayList<Edge> edges) {
	public Node(Shape shape, int pitch, ArrayList<Edge> edges) {
		this.shape = shape;
		this.pitch = pitch;
		// this.decoration = decoration;
		this.neighbor_edges = edges;

	}

	public void addEdge(Edge e) {
		this.neighbor_edges.add(e);
	}

	public ArrayList<Edge> getEdges() {
		return this.neighbor_edges;
	}

	public Shape getShape() {
		return shape;
	}

	public String getPCDecoration() {
		switch (pitch % 12) {
		case 0:
			return "C";
		case 1:
			return "C#";
		case 2:
			return "D";
		case 3:
			return "Eb";
		case 4:
			return "E";
		case 5:
			return "F";
		case 6:
			return "F#";
		case 7:
			return "G";
		case 8:
			return "Ab";
		case 9:
			return "A";
		case 10:
			return "Bb";
		case 11:
			return "B";
		default:
			return "??";
		}
	}

	public String getDecoration() {
		return getPCDecoration() + (pitch / 12);
	}

	public int getPitch() {
		return pitch;
	}

	// public int getMidiNote(){
	// return 60;
	// }
}
