package Model.Music;

import java.util.HashSet;


public class HeptatonicUnfoldedTonnetz extends PlanarUnfoldedTonnetz {

	public HeptatonicUnfoldedTonnetz(Scale s){
		assert (s.size()==7) : "The scale is not heptatonic";
		_gcd=1;
		_scale=s;
		_N=7;
		_generators = new TonnetzGen(new int[]{1,2,4});
		_pitch_class_set = new HashSet<Integer>(s);
	}
	
	@Override
	public String toHTMLString(){
		StringBuffer s = new StringBuffer("<html>T<sub>["+_generators.get(0));
			s.append("hept");
		s.append("]</sub></html>");
		return s.toString();		
	}
	
	public Scale get_scale(){
		return _scale;
	}
	
	@ Override
	public String toString(){
		
		return _scale.toString();
		
	}
	

}
