package Model.Music;

import java.util.ArrayList;
import java.util.HashSet;


public class Ring {
	
	/**
	 * @uml.property  name="_list"
	 * @uml.associationEnd  multiplicity="(0 -1)" elementType="java.lang.Integer"
	 */
	protected ArrayList<Integer> _list;
	
	public Ring(){}
	
	public Ring(ArrayList<Integer> list){
		_list = list;
	}
	
	public Ring(int[] t){
		_list = new ArrayList<Integer>();
		for (int i=0;i<t.length;i++) _list.add(t[i]);
	}
	
	public boolean equals(Ring r2){
		if (this.size()!=r2.size()) return false;
		if (get_list().equals(r2.get_list())) return true;
		if (!(new HashSet<Integer>(this._list)).equals(new HashSet<Integer>(r2.get_list()))) return false;
		
		int first = _list.get(0);
		
		ArrayList<Integer> first_elem_pos_list = new ArrayList<Integer>();
		for (int i = 0;i<r2.size();i++){
			if (r2.get(i)==first) first_elem_pos_list.add(i);
		}
		
		for (int i = 0;i<first_elem_pos_list.size();i++){
			if (_list.equals(turn(r2,first_elem_pos_list.get(i)).get_list())) return true;
		}
		
		return false;
		
	}
	
	public int size(){
		return _list.size();
	}
	
	private int get(int i){
		return _list.get(i);
	}
	
	public int next(int i){
		return _list.get((i+1)%(size()));
	}
	
	public int prev(int i){
		return _list.get((i-1+size())%size());
	}
	
	public ArrayList<Integer> get_list() {
		return _list;
	}
	
	public void set_list(ArrayList<Integer> _list) {
		this._list = _list;
	}
	
	public Boolean is_contained(ArrayList<Ring> ring_list){
		
		for (Ring r : ring_list){
			if (this.equals(r)) return true;
		}
		return false;
	}

	public Boolean is_containedSI(ArrayList<STIntervallicStructure> ring_list){
		
		for (Ring r : ring_list){
			if (this.equals(r)) return true;
		}
		return false;
	}

	public static Ring turn(Ring r,int n){
		ArrayList<Integer> new_list = new ArrayList<Integer>();
		for (int i=0;i<r.get_list().size();i++){
			new_list.add(r.get((i+n)%r.size()));
		}
		return new Ring(new_list);
	}
	
	
	public String toString(){
		return _list.toString();
	}

}
