package Model.Music;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;


public class STChord extends HashSet<Integer> {
	
	private static final long serialVersionUID = 6140332455097484769L;
	private int N = 12;
	private int M = (N/2)-(N%2);
	private int _orbit;

	public STChord() {
		super();
	}
	
	public STChord(ArrayList<Integer> list) {
		super();
		for(Integer n : list) add(n%N);
	}

	public STChord(HashSet<Integer> list) {
		super();
		for(Integer n : list) add(n%N);
	}

	public STChord(int n1, int n2, int n3) {
		super();
		add(n1);
		add(n2);
		add(n3);
	}
	
	public void addElement(int n) {
		add(n);
	}

	public boolean member(Integer n) {
		return contains(n);
	}

	public HashSet<Integer> get_intersection(HashSet<Integer> set) {
		HashSet<Integer> intersection = new HashSet<Integer>();
		for (Integer i : set) {
			if (contains(i)) intersection.add(i);
		}
		return intersection;
	}

	public UnfoldedSimplicialTonnetz getTonnetz() {
		System.out.println("chord : "+this);
		return (new STIntervallicStructure(this)).getTonnetz();
	}
	
	public UnfoldedSimplicialTonnetz get_corresponding_Tonnetz(ArrayList<UnfoldedSimplicialTonnetz> tonnetzs){
		
		assert size()==3 : "STChord.get_corresponding_Tonnetz : not yet implemented for more than 3-chords";
		for (UnfoldedSimplicialTonnetz t : tonnetzs){
			if (t.get_IntervalVectorU().equals(get_IntervalVector())) return t;
		}
		return null;
	}
	
	// Fonction retournant l'ensemble des accords "proches" d'un accord ie. on ne change qu'une note et d'un demi-ton.
	
	public ArrayList<STChord> semitone_close_chords(){
		ArrayList<STChord> list = new ArrayList<STChord>();
		ArrayList<Integer> chord_l = new ArrayList<Integer>(this);
		ArrayList<Integer> c;
		for (int i=0;i<chord_l.size();i++){
			c = new ArrayList<Integer>(this);
			c.set(i, (c.get(i)+1)%12);
			System.out.println("1 : "+c);
			STChord stChord = new STChord(c);
			if (stChord.size()==this.size()) list.add(stChord);
			c = new ArrayList<Integer>(this);
			c.set(i, (c.get(i)-1+12)%12);
			System.out.println("2 : "+c);
			stChord = new STChord(c);
			if (stChord.size()==this.size()) list.add(stChord);
			
		}
		return list;
	}
	
	public int interval_count() {
		return ((this.size()-1)*(this.size()))/2;
	}
	
//	public float tonnetz_compliance(SimplicialTonnetz t) {
//		
//		IntervallicVector ivc = get_IntervalVector();
////		IntervallicVector ivt = t.get_IntervalVectorU();
//		IntervallicVector ivt = t.get_IntervalVectorF();
//
//		
//		int sum = ivc.dot_product(ivt);
//		//return (float)sum/(float)this.interval_count();
//		return sum-t.get_compliance_coef_table()[size()]; // test pour la nouvelle compliance "non normalise sur [0-1]". Par contre on lui retire directement la valeur moyenne dpendant de la taille de l'accord
//	}
	
//	public float tonnetz_abslolute_compliance(IntervallicVector t_iv){
//		if (get_IntervalContent_set().equals(t_iv.get_interval_content_set())) return 1;
//		else return 0;
//	}
//	
	public float tonnetz_2_compliance(IntervallicVector t_iv){
		if (size()<3) return 0;
		float compliance = 0f;
		STChord c = new STChord();
		ArrayList<Integer> list = new ArrayList<Integer>(this);
		for(int n0=0; n0<this.size();n0++){
			c.add(list.get(n0));
			for(int n1=n0+1; n1<this.size();n1++){
				c.add(list.get(n1));
				for(int n2=n1+1; n2<this.size();n2++){
					c.add(list.get(n2));
//					System.out.println("c : "+c+" "+c.get_IntervalVector().dot_product(t_iv));
					if (c.get_IntervalVector().dot_product(t_iv)>=3)
//					System.out.println("ivt : "+t_iv+"  ivc : "+c.get_IntervalVector());
//					if (c.get_IntervalVector().equals(t_iv))
						compliance++;
					c.remove(list.get(n2));
				}
				c.remove(list.get(n1));
			}
			c.remove(list.get(n0));
		}
		return compliance/Binomial.binom(size(), 3);		
	}
	
	public float tonnetz_2_compliance(UnfoldedSimplicialTonnetz t) {
		return tonnetz_2_compliance(t.get_IntervalVectorF());
	}
	
	public ArrayList<UnfoldedSimplicialTonnetz> most_compliant_tonnetz(ArrayList<UnfoldedSimplicialTonnetz> tonnetzs){
		ArrayList<UnfoldedSimplicialTonnetz> best_tonnetz = new ArrayList<UnfoldedSimplicialTonnetz>();
		float comp_max = 0;
		for (UnfoldedSimplicialTonnetz t : tonnetzs){
			if (tonnetz_2_compliance(t)>comp_max){
				best_tonnetz.clear();
				best_tonnetz.add(t);
				comp_max = tonnetz_2_compliance(t);
			} else if (tonnetz_2_compliance(t) == comp_max){
				best_tonnetz.add(t);
			}
		}
		if (best_tonnetz.size()!=tonnetzs.size())
			return best_tonnetz;
		else return new ArrayList<UnfoldedSimplicialTonnetz>();
	}

//	public float tonnetz_2_compliance(FoldedTonnetz t) {
//		return tonnetz_2_compliance(t.get_IntervalVector());
//	}
	
//	public float tonnetz_1_compliance(IntervallicVector t_iv){
//		if (size()<2) return 0;
//		float compliance = 0f;
//		STChord c = new STChord();
//		ArrayList<Integer> list = new ArrayList<Integer>(this);
//		for(int n0=0; n0<this.size();n0++){
//			c.add(list.get(n0));
//			for(int n1=n0+1; n1<this.size();n1++){
//				c.add(list.get(n1));
////					System.out.println("c : "+c+" "+c.get_IntervalVector().dot_product(ivt));
//				if (c.get_IntervalVector().dot_product(t_iv)==1) compliance++;
//				c.remove(list.get(n1));
//			}
//			c.remove(list.get(n0));
//		}
//		return compliance/Binomial.binom(size(), 2);		
//	}
//
//	public float tonnetz_1_compliance(UnfoldedSimplicialTonnetz t) {
//		return tonnetz_1_compliance(t.get_IntervalVectorF());
//	}
//
//	public float tonnetz_1_compliance(FoldedTonnetz t) {
//		return tonnetz_1_compliance(t.get_IntervalVector());
//	}
//	
//	public float tonnetz_abs_compliance(FoldedTonnetz t){
//		return tonnetz_abslolute_compliance(t.get_IntervalVector());
//	}

	
	public String toString() {
		String s = "";
		for(Integer n : this) s = s.concat(n+" ");
		return s;
	}
	
	public STChord transposition(int t) {
		STChord c = new STChord();
		for(Integer n : this) c.add((n+t)%N);
		return c;
	}
	
	public STChord inversion(int i) {
		STChord c = new STChord();
		for(Integer n : this) c.add((i-n+N)%N);
		return c;
	}
	
	public int get_smallest_pitch() {
		ArrayList<Integer> list = new ArrayList<Integer>(this);
		return list.get(0);
	}
	public int get_orbit(UnfoldedSimplicialTonnetz t) {
		_orbit = (get_smallest_pitch())%(Gcd.gcd(t._generators));
		return _orbit;
	}
	public ArrayList<Integer> get_intervallic_structure() {
		return new STIntervallicStructure(this).get_list();
	}
	
	public IntervallicVector get_IntervalVector() {	// Allen Forte. Ex : (O,4,7) -> [001110] (0,4,7,10) -> [012111]]
		
		ArrayList<Integer> list = new ArrayList<Integer>(this);
		Collections.sort(list);
		int iv[] = new int[M];
		for (int i : iv) iv[i]=0;
		for (int i=0; i<this.size() ;i++) {
			for (int j = i+1; j<this.size() ; j++) {
				//iv[-Math.abs((list.get(j)-list.get(i))-M)+M-1]++;
				iv[Interval.MI((list.get(j)-list.get(i)), N)-1]++;
			}
		}
		return new IntervallicVector(iv);
	}
		
	public HashSet<Integer> get_IntervalContent_set() {
		return get_IntervalVector().get_interval_content_set();
	}
	
	public Bag get_IntervalContent_multiset() {
		Bag multi_set = new Bag();
		IntervallicVector vector = get_IntervalVector();
		for (int i=0;i<vector.size();i++){
			if (vector.get(i)!=0){
				for (int j=1;j<=vector.get(i);j++){
					multi_set.add(i+1);	
				}
			}
		}
		return multi_set;
	}

	public static STChord random_STChord(int size, int N){
		STChord chord = new STChord();
		while (chord.size()!=size){
			chord.add((int)(1000*Math.random())%N);
		}
		return chord;
	}
}
