package Model.Music;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;


//class STIntervallicStructure extends ArrayList<Integer> {
public class STIntervallicStructure extends Ring {
	
	private static final long serialVersionUID = 3799049669137157854L;

	public STIntervallicStructure(STChord ch) {
		super();

		// Listify the chord pitches
		ArrayList<Integer> notes = new ArrayList<Integer>();
		for(Integer n : ch) notes.add(n);

		// Sort list of pitches
		Collections.sort(notes);

		// Pairwise differences
		ArrayList<Integer> intervals = new ArrayList<Integer>();
		int i;
		for(i=0; i<notes.size(); i++) intervals.add(((notes.get((i+1)%notes.size()) - notes.get(i))+12)%12);
		set_list(intervals);
	}
	
	public STIntervallicStructure(ArrayList<Integer> list){
		super(list);
	}

	public STIntervallicStructure(int[] list){
		super(list);
	}

	public UnfoldedSimplicialTonnetz getTonnetz() {
		return UnfoldedSimplicialTonnetz.getTonnetz(this);
	}
	
	public STChord get_default_STChord(){
		STChord c = new STChord();
		c.add(0);
		int n=0;
		for (int i=0;i<_list.size()-1;i++){
			c.add(n+_list.get(i));
			n=n+_list.get(i);
		}
		return c;

	}
	
	public IntervallicVector get_IntervalVector() {	// Allen Forte. Ex : (O47) -> [001110]
		
		return get_default_STChord().get_IntervalVector();
	}
	
	public HashSet<Integer> get_IntervalContent_set() {
		
		return get_default_STChord().get_IntervalContent_set();
	}
	
	public Bag get_IntervalContent_multiset() {

		return get_default_STChord().get_IntervalContent_multiset();
	}
	
	public Bag get_bag(){
		return new Bag(_list);
	}

	
	public static ArrayList<STIntervallicStructure> enum_SI(int size, int N){
		
		ArrayList<STIntervallicStructure> ring_list = new ArrayList<STIntervallicStructure>();
		if (size == 0) return ring_list;
		if (size == 1) {
			ring_list.add(new STIntervallicStructure(new int[]{0}));
			return ring_list;
		}
		if (size == N){
			ArrayList<Integer> list = new ArrayList<Integer>();
			for (int i=0;i<N;i++){
				list.add(1);
			}
			ring_list.add(new STIntervallicStructure(list));
		}
		
		int max = N+1-size;
				
		int[] si = new int[size];
		for (int i = 0;i<size;i++) si[i]=1;
		
		while(!(si[size-1]==max)){
			int sum = 0;
			for (int in : si) sum=sum+in;
			if (sum==N) {
				STIntervallicStructure ring_si = new STIntervallicStructure(si);
				if (!ring_si.is_containedSI(ring_list)) ring_list.add(ring_si);
			}
		
			int i=0;
			boolean b = true;
			
			while (b){
				if(si[i]==max){
					si[i]=1;
					i++;
				} else {
					si[i]++;
					i = 0;
					b = false;
				}
			}
		}
		return ring_list;
	}
}
