package Model.Music;

import java.util.ArrayList;

public class Scale extends ArrayList<Integer>{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private int _N;
	private int _pitch;
	private String _mode_name;
	private ArrayList<Integer> _mode;
	
	
	
	public Scale(int tonic, String mode_name){
		_N=0;
		_mode_name=mode_name;
		assert (mode_name.equals("major") || mode_name.equals("minor") || mode_name.equals("Hminor") || mode_name.equals("chromatic")) : "Unknown mode";
		if (mode_name.equals("major")) _mode = get_major_mode();
		if (mode_name.equals("minor")) _mode = get_minor_mode();
		if (mode_name.equals("Hminor")) _mode = get_Hminor_mode();
		if (mode_name.equals("chromatic")) _mode = get_chromatic_mode();
		for (int i : _mode){
			_N+=i;
		}
		_pitch = tonic;
		add(tonic);
		for (int i=0;i<_mode.size()-1;i++){
			add((get(this.size()-1)+_mode.get(i))%_N);
		}
	}
	
	public static ArrayList<Integer> get_major_mode(){
		ArrayList<Integer> list = new ArrayList<Integer>();
		list.add(2);
		list.add(2);
		list.add(1);
		list.add(2);
		list.add(2);
		list.add(2);
		list.add(1);
		return list;
	}
	
	public static ArrayList<Integer> get_minor_mode(){
		ArrayList<Integer> list = new ArrayList<Integer>();
		list.add(2);
		list.add(1);
		list.add(2);
		list.add(2);
		list.add(1);
		list.add(2);
		list.add(2);
		return list;
	}

	public static ArrayList<Integer> get_Hminor_mode(){
		ArrayList<Integer> list = new ArrayList<Integer>();
		list.add(2);
		list.add(1);
		list.add(2);
		list.add(2);
		list.add(1);
		list.add(3);
		list.add(1);
		return list;
	}
	
	public static ArrayList<Integer> get_chromatic_mode(){
		ArrayList<Integer> list = new ArrayList<Integer>();
		for (int i=0;i<12;i++) list.add(1);
		return list;
	}

	public static Scale get_chromatic_scale(int N){
		return new Scale(0,"chromatic");
	}
	
	public int get_pitch(int n){
		int m = n;
		while(m<0) m=m+size();
		m = m%size();
		return get(m);
	}
	
	public String toString(){
		return Note.get_name(_pitch)+" "+_mode_name;		
	}
}
