package Model.Music;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;



import Utils.Gcd;
import Utils.Table;


public class UnfoldedSimplicialTonnetz extends PlanarUnfoldedTonnetz {

	private float[] compliance_coef_table;
	
	

	private UnfoldedSimplicialTonnetz(ArrayList<Integer> list) {
		_N=0;
		_gcd=0;
		_coords = null;
		_generators = new TonnetzGen(list);
		for(Integer n : list) {
			_N += n;
			if (_gcd==0) _gcd = n; else _gcd = Gcd.gcd(_gcd, n);
		}
		_scale = Scale.get_chromatic_scale(_N);
		_pitch_class_set = new HashSet<Integer>();
		for(int i = 0;i < _N;i++ ) {
			_pitch_class_set.add(i);
		}
	}
	
	public UnfoldedSimplicialTonnetz(STChord c){
		_N=12;
		Bag b = c.get_IntervalContent_multiset();
		_generators = new TonnetzGen(b);
		for(Integer n : b) {
			if (_gcd==0) _gcd = n; else _gcd = Gcd.gcd(_gcd, n);
		}
		_scale = Scale.get_chromatic_scale(_N);
		_pitch_class_set = new HashSet<Integer>();
		for(int i = 0;i < _N;i++ ) {
			_pitch_class_set.add(i);
		}
		
	}
	
//	public UnfoldedSimplicialTonnetz(STIntervallicStructure is){
//		_dim = is.size()-1;
//		_N = 0;
//		for (Integer i : is.get_list()){
//			_N+=i;
//		}
//	}
	
	public STChord get_representative_chord(){
		STChord c = new STChord();
		c.add(0);
		int n=0;
		for (int i=0;i<_generators.size()-1;i++){
			c.add(n+_generators.get(i));
			n=_generators.get(i);
		}
		return c;
	}
	
//	public void compliance_coef_table_init(){
//		compliance_coef_table = new float[_N+1];
//		compliance_coef_table[0]=0;
//		compliance_coef_table[1]=0;
//		
//		for (int n=2;n<=_N;n++){
//			int contained_intervals = 0;
//			for (int p = 1;p<n;p++) contained_intervals+=p;
//			compliance_coef_table[n]=contained_intervals*(1/getZ12HexaTonnetz_compliance_coef(this));
//		}
//	}
	
//	public float[] get_compliance_coef_table() {
//		return compliance_coef_table;
//	}
	
//	public TonnetzCoord toCoord(int n) {
//		if ((n%_gcd)!=0) return new TonnetzCoord(); // si la note n'existe pas dans le rseau (pas la bonne orbite)
//		return toCoords(n).get(0);
//	}
//
//	public ArrayList<TonnetzCoord> toCoords(int n) {	// n = pitch class
//		//assert(n>0);
//		n = ((n%_N) + _N) % _N;
//		if ((n%_gcd)!=0) return new ArrayList<TonnetzCoord>();
//		if (_coords==null) build_coords();
//		return new ArrayList<TonnetzCoord>(_coords.get(n));
//	}


//	private void build_coords() {
//		int i;
//		_coords = new TreeMap<Integer,TreeSet<TonnetzCoord>>();
//
//		TonnetzCoord zero = new TonnetzCoord();
//		//for(i=0;i<_dim;i++) zero.add(0);
//		for(i=0;i<_generators.size();i++) zero.add(0);
//
//		TreeSet<TonnetzCoord> workList = new TreeSet<TonnetzCoord>();
//		workList.add(zero);
//		_coords.put(0,workList);
//
//		workList = new TreeSet<TonnetzCoord>();
//		workList.add(zero);
//		
//		while(true) {
//			TreeSet<TonnetzCoord> neoWorkList = new TreeSet<TonnetzCoord>();
//
//			for(TonnetzCoord c : workList) {
//				//for(i=0;i<_dim;i++) {
//				for(i=0;i<_generators.size();i++) {
//					int x = c.get(i);
//					if (x>=0) {
//						TonnetzCoord nc = new TonnetzCoord(c);
//						nc.set(i, x+1);
//						if (!_coords.containsKey(toNote(nc))) neoWorkList.add(nc);
//					}
//					if (x<=0) {
//						TonnetzCoord nc = new TonnetzCoord(c);
//						nc.set(i, x-1);
//						if (!_coords.containsKey(toNote(nc))) neoWorkList.add(nc);
//					}
//				}
//			}
//
//			if (neoWorkList.size() == 0) break;
//
//			for(TonnetzCoord c : neoWorkList) {
//				int n = toNote(c);
//				TreeSet<TonnetzCoord> l = _coords.get(n);
//				if (l == null) {
//					l = new TreeSet<TonnetzCoord>();
//					_coords.put(n,l);
//				}
//				l.add(c);
//			}
//			
//			workList=neoWorkList;
//		}
//	}

//  TRANSFEREE DANS Tonnetz.java
//	public int toNote(ArrayList<Integer> coord) {
//		//assert(coord.size()==_dim);
//		assert(coord.size()==_generators.size());
//		int i;
//		int n=0;
//		//for(i=0;i<_dim;i++) n += coord.get(i)*_generators.get(i);
//		for(i=0;i<_generators.size();i++) n += coord.get(i)*_generators.get(i);
//		return Gcd.reduce(n,_N);
//	}
	
//  TRANSFEREE DANS Tonnetz.java	
//	public static int[] to_2gen_coords(TonnetzCoord c){ // Ex Si dans [3,4,5] : [0,1,-1] => [-1,2] (puisque X = g0 et Y = -g2 dans les rseaux hexagonaux)
//		int[] coord = new int[2];
//		assert(c.size()==3) : "Error : method to_2gen_coords is only implemented for 3-generators simplicial Tonnetz for 2D-hexagonal representation";
//		coord[0]=c.get(0)-c.get(1);
//		coord[1]=-c.get(2)+c.get(1);
//		return coord;
//	}

//  TRANSFEREE DANS Tonnetz.java
//	public static TonnetzCoord normalized_coord(TonnetzCoord c){
//		if (c.size() != 3) System.err.println("norm Not yet implemented for non-hexagonal representations");
//		TonnetzCoord coord = new TonnetzCoord();
//		coord.add(c.get(0)-c.get(2));
//		coord.add(c.get(1)-c.get(2));
//		coord.add(0);
//		return coord;
//	}
	
//  TRANSFEREE DANS Tonnetz.java	
//	public static ArrayList<int[]> to_2gen_coords(ArrayList<TonnetzCoord> list){
//		ArrayList<int[]> coord_list = new ArrayList<int[]>();
//		for (TonnetzCoord c : list) coord_list.add(to_2gen_coords(c));
//		return coord_list;
//	}
	
//	// TODO : peut tre optimis
//	public static TonnetzCoord to_3gen_coords(int[] c){
//		if (c.length!=2) System.err.println("Not yet implemented for more than 2-dimensional representations (i.e more than 2 coordinates");
//		TonnetzCoord ton_coord = new TonnetzCoord();
////		ton_coord.add(c[0]);
////		ton_coord.add(0);
////		ton_coord.add(-c[1]);
//		ton_coord.add(c[0]+c[1]);
//		ton_coord.add(c[1]);
//		ton_coord.add(0);
//		return ton_coord;
//	}

	static private TreeMap<TonnetzGen,UnfoldedSimplicialTonnetz> _tonnetzs = new TreeMap<TonnetzGen,UnfoldedSimplicialTonnetz>();

	static public UnfoldedSimplicialTonnetz getTonnetz(ArrayList<Integer> list) {
		TonnetzGen k = new TonnetzGen(list);
		UnfoldedSimplicialTonnetz t = _tonnetzs.get(k);
		if (t==null) {
			t = new UnfoldedSimplicialTonnetz(list);
			_tonnetzs.put(t.get_generators(),t);
		}
		return t;
	}
	
	static public UnfoldedSimplicialTonnetz getTonnetz(STIntervallicStructure is){
		return new UnfoldedSimplicialTonnetz(is.get_list());
	}

	static public UnfoldedSimplicialTonnetz getTonnetz(int i1, int i2, int i3) {
		ArrayList<Integer> l = new ArrayList<Integer>();
		l.add(i1);
		l.add(i2);
		l.add(i3);
		return getTonnetz(l);
	}
	
	private static ArrayList<UnfoldedSimplicialTonnetz> _z12HexaTonnetzList;
	
	public static ArrayList<UnfoldedSimplicialTonnetz> getZ12HexaTonnetzList() {
		if (_z12HexaTonnetzList == null) {
			_z12HexaTonnetzList = new ArrayList<UnfoldedSimplicialTonnetz>();
			_z12HexaTonnetzList.add(getTonnetz(1,1,10));
			_z12HexaTonnetzList.add(getTonnetz(1,2,9));
			_z12HexaTonnetzList.add(getTonnetz(1,3,8));
			_z12HexaTonnetzList.add(getTonnetz(1,4,7));
			_z12HexaTonnetzList.add(getTonnetz(1,5,6));
			_z12HexaTonnetzList.add(getTonnetz(2,2,8));
			_z12HexaTonnetzList.add(getTonnetz(2,3,7));
			_z12HexaTonnetzList.add(getTonnetz(2,4,6));
			_z12HexaTonnetzList.add(getTonnetz(2,5,5));
			_z12HexaTonnetzList.add(getTonnetz(3,3,6));
			_z12HexaTonnetzList.add(getTonnetz(3,4,5));
			_z12HexaTonnetzList.add(getTonnetz(4,4,4));
		}		
		return _z12HexaTonnetzList;
	}
	
	public static float getZ12HexaTonnetz_compliance_coef(UnfoldedSimplicialTonnetz t){
		float coef = 0;
		HashSet<Integer> G = new HashSet(t._generators);
//		System.out.println("voici le set : "+G);
		
		// si N est paire
		if (t._N%2==0){
			for (int g : G){
				if (g!=t._N/2) {
					coef = coef+2/(float)(t._N-1);
				}
				else coef = coef+1/(float)(t._N-1);
			}
		} else { // si N est impaire
			for (int g : G){
				coef = coef+2/(float)(t._N-1);
			}
		}
		return 1/coef;
	}

	public static int getZ12HexaTonnetzIndex(UnfoldedSimplicialTonnetz h) {
		// TODO: relies on object references !!!
		return getZ12HexaTonnetzList().indexOf(h);
	}

//	public int get_orbitCount() {
//		return _gcd;
//	}
//
//	public int getOrbit(int note) {
//		note = Gcd.reduce(note, _N);
//		return note%_gcd;
//	}
//	
//	public int getOrbit(STChord ch) {
//		int t[] = new int[_gcd];
//		int i; for(i=0;i<_gcd;i++) t[i]=0;
//		for(Integer n : ch) t[getOrbit(n)]++;
//		int o=0;
//		for(i=1;i<_gcd;i++) if (t[o]<t[i]) o=i;
//		return o;
//	}
	
//	// renvoi les premires coord trouves associs au pitch n dans une List de TonnetzCoord. Si aucun lment ne correspond, null est renvoy
//	public TonnetzCoord pitch_in_list(ArrayList<TonnetzCoord> list, int pitch){
//		for (TonnetzCoord c : list) if (t_coords_to_pitch(c)==pitch) return c;
//		return null;
//	}
//	
//	// renvoi le pitch associ  des XYcoordonnes
//	public int xy_coords_to_pitch(int[] coords){
//		if (coords.length != 2) System.err.println("method coords_to_pitch implemented for XY coords only");
//		return Gcd.reduce(coords[0] * get_generator(0) - coords[2] * get_generator(2), _N);		
//	}

//	// renvoi les pitchs (et leurs Tcoordonnees) voisins d'une position 
//	public Hashtable neighbor_pitchs(TonnetzCoord coord){
//		Hashtable table = new Hashtable();
//		TonnetzCoord tc;
//		for (int i=0;i<_generators.size();i++){
//			tc = new TonnetzCoord(coord);
//			tc.move_one_gen_more(i);
//			table.put(tc, t_coords_to_pitch(tc));
//			tc = new TonnetzCoord(coord);
//			tc.move_one_gen_less(i);
//			table.put(tc, t_coords_to_pitch(tc));
//			//table.put(coord.move_one_gen_more(i), t_coords_to_pitch(coord.move_one_gen_more(i)));
//			//table.put(coord.move_one_gen_less(i), t_coords_to_pitch(coord.move_one_gen_less(i)));
//		}
//		return table;
//	}
//	
//	// renvoi les coordonnes voisines d'une note
//	public ArrayList<TonnetzCoord> neighbor_coords(TonnetzCoord coord){
//		ArrayList<TonnetzCoord> list = new ArrayList<TonnetzCoord>();
//		TonnetzCoord tc;
//		for (int i=0;i<_generators.size();i++){
//			tc = new TonnetzCoord(coord);
//			tc.move_one_gen_more(i);
//			list.add(normalized_coord(tc));
//			tc = new TonnetzCoord(coord);
//			tc.move_one_gen_less(i);
//			list.add(normalized_coord(tc));
//		}
//		return list;
//	}
	
//	// renvoi la liste des coordonnes des plus proches pitchs d'une certaine position. Renvoi vide si le pitch n'est pas dans le rseau
//	public ArrayList<TonnetzCoord> closest_pitches_Tcoords(int pitch, TonnetzCoord coords){
//		ArrayList<TonnetzCoord> pitches_coords = new ArrayList<TonnetzCoord>();
//		Hashtable table = neighbor_pitchs(coords);
//		return pitches_coords;
//	}
//	
//	// renvoi le cercle largit avec UNIQUEMENT les coord dont le pitch associ n'appartenaient pas au cercle avant largissement
//	public ArrayList<TonnetzCoord> enlarge_circle(ArrayList<TonnetzCoord> prev_c){
//		if (prev_c.size()==1) return neighbor_coords(prev_c.get(0));
//		HashSet<TonnetzCoord> new_c = new HashSet<TonnetzCoord>();
//		for (TonnetzCoord c : prev_c) {
//			ArrayList<TonnetzCoord> loc = neighbor_coords(c);
//			for (TonnetzCoord cc : loc) if (!prev_c.contains(cc)) new_c.add(cc);
//		}
//		return new ArrayList<TonnetzCoord>(new_c);
//	}
	
	// renvoi la liste des TonnetzCoord des pitchs du premier accord
	
//	public ArrayList<TonnetzCoord> first_chord_coords(STChord c){
//		ArrayList<TonnetzCoord> coords_set = new ArrayList<TonnetzCoord>();
//		STChord to_draw = c;
//		TonnetzCoord searched_note_coords = toCoord(c.get_smallest_pitch());
//		coords_set.add(searched_note_coords);
//		if (c.size() == 1) return coords_set;		
//		to_draw.remove(c.get_smallest_pitch());
//		ArrayList<TonnetzCoord> circle = coords_set;
//			while(to_draw.size()!=0){
//				circle = enlarge_circle(circle);
//				int searched_pitch = to_draw.get_smallest_pitch();
//				searched_note_coords = pitch_in_list(circle, searched_pitch);
//				if (searched_note_coords!=null) {
//					coords_set.add(searched_note_coords);
//					to_draw.remove(searched_pitch);
//					circle = coords_set;
//				}
//			}		
//		return coords_set;
//	}
	
//	public ArrayList<TonnetzCoord> coords_subset(STChord c, ArrayList<TonnetzCoord> coords_set){
//		ArrayList<TonnetzCoord> subset = new ArrayList<TonnetzCoord>();
//		for (TonnetzCoord coord : coords_set){
//			if (c.contains(t_coords_to_pitch(coord))){
//				subset.add(coord);
//			}
//		}
//		return subset;
//	}
	
//	public ArrayList<TonnetzCoord> n_chord_coords(STChord c, ArrayList<TonnetzCoord> prev_coords){
//		ArrayList<TonnetzCoord> coords_set = new ArrayList<TonnetzCoord>();
//		STChord to_draw = c;
//		
//		for (TonnetzCoord tc : prev_coords){
//			if (c.contains(t_coords_to_pitch(tc))) {
//				coords_set.add(tc);
//				to_draw.remove(t_coords_to_pitch(tc));
//			}
//		}
//		// Premier cas : le nouvel accord est un sous-accord du prcdent -> pas de recherche
//		if (to_draw.isEmpty()) return coords_set;
//		
//		ArrayList<TonnetzCoord> circle = coords_set;
//
//		// Second cas : le nouvel accord n'a aucune note en commun avec le prcdent. Le cercle de recherche grossit  partir de l'accord prcdent
//		if (coords_set.isEmpty()){
//			circle = prev_coords;
//			while (to_draw.size()!=0){
//				circle = enlarge_circle(circle);
//				ArrayList<TonnetzCoord> candidats = coords_subset(to_draw,circle);
//				if (candidats.size() > 0){
//					coords_set.add(candidats.get(0));
//					to_draw.remove(t_coords_to_pitch(candidats.get(0)));
//					circle = coords_set;
//				}
//			}
//
//		} else {
//		// Troisime cas : les deux accords ont un sous-ensemble en commun OU l'ancien est un sous ensemble du nouveau. Le cercle de recherche grossit  partir de l'intersection des 2.
//			ArrayList<TonnetzCoord> erased_notes = new ArrayList<TonnetzCoord>();
//			for (TonnetzCoord tc : prev_coords){
//				if (!coords_set.contains(tc)) erased_notes.add(tc);
//			}
//			circle = coords_set;
//			while (to_draw.size()!=0){
//				circle = enlarge_circle(circle);
//				TonnetzCoord new_choosen_coord = null;
//				ArrayList<TonnetzCoord> candidats = coords_subset(to_draw,circle);
//				if (candidats.size() > 1) {
//					new_choosen_coord = candidats.get(0);
//					for (TonnetzCoord cand : candidats) {
//						if (enlarge_circle(erased_notes).contains(cand)) new_choosen_coord = cand;
//					}
//				} else {
//					if (candidats.size() == 1) new_choosen_coord = candidats.get(0);
//				}
//				if (new_choosen_coord != null) {
//					coords_set.add(new_choosen_coord);
//					to_draw.remove(t_coords_to_pitch(new_choosen_coord));
//					circle = coords_set;
//				}
//			}
//
//		}
//		return coords_set;
//	}
	
//	public ArrayList<int[]> first_chord_XYcoords(STChord c){
//		ArrayList<TonnetzCoord> pop = first_chord_coords(c);
//		return to_2gen_coords(pop);
//	}
//	
//	public ArrayList<int[]> n_chord_XYcoords(STChord c, ArrayList<int[]> prev_coords){
//		if (prev_coords == null) return first_chord_XYcoords(c);
//		ArrayList<TonnetzCoord> prev = new ArrayList<TonnetzCoord>();
//		for (int[] co : prev_coords) {
//			prev.add(to_3gen_coords(co));
////			System.out.println(Table.toString(co));
////			System.out.println(to_3gen_coords(co));
//		}
//		
//		return to_2gen_coords(n_chord_coords(c, prev));
//		//return to_2gen_coords(enlarge_circle(prev));
//	}
	
	// Fonction retournant la liste des Tonnetz voisins d'un Tonnetz selon le critre : 
	// 2 Tonnetz sont voisins si un mouvement minimal permet de passer de l'un  l'autre
	public HashSet<UnfoldedSimplicialTonnetz> neighbor_tonnetzs(){
		HashSet<UnfoldedSimplicialTonnetz> list = new HashSet<UnfoldedSimplicialTonnetz>();
		STChord c = this.get_representative_chord();
		ArrayList<STChord> neighbors = c.semitone_close_chords();
		for (STChord n : neighbors){
			UnfoldedSimplicialTonnetz t = n.get_corresponding_Tonnetz(UnfoldedSimplicialTonnetz.getZ12HexaTonnetzList());
			if (t!=null && t!=this) list.add(t);
		}
		return list;
	}
	
	// Fonction retournant la liste des Tonnetz voisins dans le graphe des Tonnetz selon le critre  :
	// 2 Tonnetz sont voisins si un mouvement minimal permet de passer de l'un  l'autre
	public static HashSet<HashSet<UnfoldedSimplicialTonnetz>> neighbor_list(ArrayList<UnfoldedSimplicialTonnetz> tonnetzs){
		HashSet<HashSet<UnfoldedSimplicialTonnetz>> neighbor_list = new HashSet<HashSet<UnfoldedSimplicialTonnetz>>();
		for (UnfoldedSimplicialTonnetz t : UnfoldedSimplicialTonnetz.getZ12HexaTonnetzList()){
			HashSet<UnfoldedSimplicialTonnetz> set = t.neighbor_tonnetzs();
			for (UnfoldedSimplicialTonnetz n : set){
				HashSet<UnfoldedSimplicialTonnetz> neighborhood = new HashSet<UnfoldedSimplicialTonnetz>();
				neighborhood.add(n);
				neighborhood.add(t);
				neighbor_list.add(neighborhood);
			}
		}
		return neighbor_list;
	}
	
//	public static GraphFrame dot_builder(Parameters param) {
//		ArrayList<UnfoldedSimplicialTonnetz> tonnetzs = param.get_Z12tonnetz_list();
//		HashSet<HashSet<UnfoldedSimplicialTonnetz>> neighbor_list = neighbor_list(tonnetzs);
//		GraphViz gv = new GraphViz();
//		gv.addln(gv.start_graph());
//		for (int i=0;i<tonnetzs.size();i++){
//			gv.addln(i+" [label=\""+tonnetzs.get(i)+"\"];");
//		}
//		for (HashSet<UnfoldedSimplicialTonnetz> n : neighbor_list){
//			ArrayList<UnfoldedSimplicialTonnetz> l = new ArrayList<UnfoldedSimplicialTonnetz>(n);
//			//gv.addln("\""+l.get(0)._generators+"\" -- \""+l.get(1)._generators+"\";");
//			//gv.addln(SimplicialTonnetz.getZ12HexaTonnetzIndex(l.get(0))+" -- "+SimplicialTonnetz.getZ12HexaTonnetzIndex(l.get(1)));
//			gv.addln(tonnetzs.indexOf(l.get(0))+" -- "+tonnetzs.indexOf(l.get(1))+";");
//		}
//		gv.addln(gv.end_graph());
//		System.out.println(gv.getDotSource());
//		String type = "plain";
//		File out = new File("tmp/out." + type);   // out.gif in this example
//		gv.writeGraphToFile( gv.getGraph( gv.getDotSource(), type ), out );
//		StringBuffer buffer = new StringBuffer();
//		try {
//			FileReader reader = new FileReader(out);
//			BufferedReader br = new BufferedReader(reader);
//			String line = br.readLine();
//			while (line != null){
//				buffer.append(line+" ");
//				line = br.readLine();
//			}
//		} catch (FileNotFoundException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		System.out.println("Voici le buffer : "+Table.toString(buffer.toString().split(" ")));
//		GraphFrame graph_frame = new GraphFrame(buffer.toString().split(" "), param);
//		return graph_frame;
//	}
}


