package signalprocesser.voronoi;

public class VPoint {

	/* ***************************************************** */
	// Variables

	public int x;
	public int y;
	public long t;

	/* ***************************************************** */
	// Constructors

	public VPoint() {
		this(-1, -1, 0);
	}

	public VPoint(int x, int y) {
		this(x, y, 0);
	}

	public VPoint(int _x, int _y, long time) {
		this.x = _x;
		this.y = _y;
		this.t = time;
	}

	public VPoint(VPoint point) {
		this.x = point.x;
		this.y = point.y;
		this.t = point.t;
	}

	public double distanceTo(VPoint point) {
		return Math.sqrt((this.x - point.x) * (this.x - point.x) + (this.y - point.y) * (this.y - point.y));
	}

	public String toString() {
		return "VPoint (" + x + "," + y + "," + t + ")";
	}

	/* ***************************************************** */
}
